<?php
/*
Plugin Name: Feed reading Blogroll
Plugin URI: http://www.weinschenker.name/plugin-feed-reading-blogroll/
Description: This plugin lets you embed an enhanced blogroll that reads the feeds of your bookmarked sites.
Version:  0.6.0.2
Author: Jan Weinschenker
Author URI: http://www.weinschenker.name


    Plugin: Copyright 2008  Jan Weinschenker  (email: pandorafeeds@weinschenker.name)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


// include wp rss functions
require_once (ABSPATH . WPINC . '/rss.php');

add_option('feedreading_blogroll_settings', $data, 'feedreading_blogroll Options');

load_plugin_textdomain('feedreading_blogroll');


/*
 * init widget
 */
function widget_init_feedreading_blogroll() {
	// Check for required functions
    $widget_ops = array('classname' => 'widget_feedreading_blogroll', 'description' => __('widget_feedreading_blogroll widget description ') );
    wp_register_sidebar_widget('widget_feedreading_blogroll', 'Live Blogroll', 'widget_feedreading_blogroll', $widget_ops);
    register_widget_control('widget_feedreading_blogroll', 'widget_feedreading_blogroll_control');
}


/**
 * Register with options-page
 */
function feedreading_register_with_options() {

	if (function_exists('add_options_page')) {
		add_options_page('Feed reading Blogroll', 'Feed reading Blogroll', 8, basename(__FILE__), 'feedreading_options_subpanel');
	}
}


/*
 * read http-data and set options.
 */
function feedreading_setOptions() {
    $feedreading_blogroll_settings = get_option('feedreading_blogroll_settings');
    $linkCssClass                  = $feedreading_blogroll_settings['linkCssClass'];
    $bookmarkArgs                  = $feedreading_blogroll_settings['getBookmarkArgs'];
    $feedreadingTitle              = $feedreading_blogroll_settings['feedreadingTitle'];
    $defaultIcon                   = $feedreading_blogroll_settings['defaultIcon'];
    $showLastUpdated               = $feedreading_blogroll_settings['showLastUpdated'];
    $showIcon                      = $feedreading_blogroll_settings['showIcon'];
    if (isset($_POST['linkCssClass']) or isset($_POST['getBookmarkArgs']) or isset($_POST['showLastUpdated']) or isset($_POST['feedreadingTitle']) or isset($_POST['showIcon']) or isset($_POST['defaultIcon'])) {
        $feedreading_blogroll_settings['linkCssClass']      = strip_tags(stripslashes($_POST['linkCssClass']));
        $feedreading_blogroll_settings['getBookmarkArgs']   = strip_tags(stripslashes($_POST['getBookmarkArgs']));
        $feedreading_blogroll_settings['showLastUpdated']   = strip_tags(stripslashes($_POST['showLastUpdated']));
        $feedreading_blogroll_settings['feedreadingTitle']  = strip_tags(stripslashes($_POST['feedreadingTitle']));
        $feedreading_blogroll_settings['defaultIcon']       = strip_tags(stripslashes($_POST['defaultIcon']));
        $feedreading_blogroll_settings['showIcon']          = strip_tags(stripslashes($_POST['showIcon']));
        update_option('feedreading_blogroll_settings', $feedreading_blogroll_settings);
        $feedreading_blogroll_settings['flash'] = __('Settings saved.');
    }
    return $feedreading_blogroll_settings;
}


/*
 * render the option-panel
 */
function feedreading_options_subpanel(){

    $feedreading_blogroll_settings = feedreading_setOptions();
    $linkCssClass               = $feedreading_blogroll_settings['linkCssClass'];
    $bookmarkArgs               = $feedreading_blogroll_settings['getBookmarkArgs'];
    $feedreadingTitle           = $feedreading_blogroll_settings['feedreadingTitle'];
    $showLastUpdated            = $feedreading_blogroll_settings['showLastUpdated'];
    $showIcon                   = $feedreading_blogroll_settings['showIcon'];
    $defaultIcon                = $feedreading_blogroll_settings['defaultIcon'];
    $feedreading_blogroll_flash = $feedreading_blogroll_settings['flash'];
    
    if ($feedreading_blogroll_flash != ''){
        ?><div id="message"class="updated fade"><p><?php echo $feedreading_blogroll_flash; ?></p></div><?php 
    }

?>
    <div class="wrap">
    <h2>Feed Reading Blogroll <?php _e('Options'); ?></h2>
    <form id="feedreading_options_form" action="" method="post">
    <table class="form-table">
    <tr>
        <th scope="row" valign="top"><?php _e('Blogroll Title for sidebar widget','feedreading_blogroll')?></th>
        <td>
        <input size="80"  id="feedreadingTitle" name="feedreadingTitle" type="text" value="<?php echo $feedreading_blogroll_settings['feedreadingTitle']; ?>" />
        </td>
    </tr>
    <tr>
        <th scope="row" valign="top"><?php _e('Arguments for getBookmarks()','feedreading_blogroll');?></th>
        <td>
        <input size="80" id="getBookmarkArgs" name="getBookmarkArgs" type="text" value="<?php echo $feedreading_blogroll_settings['getBookmarkArgs']; ?>" />
        </td>
    </tr>
    <tr>
        <th scope="row" valign="top"><?php _e('Default icon','feedreading_blogroll');?></th>
        <td>
        <input size="80" id="defaultIcon" name="defaultIcon" type="text" value="<?php echo $feedreading_blogroll_settings['defaultIcon']; ?>" />
        </td>
    </tr>
    <tr>
        <th scope="row" valign="top"><?php _e('CSS class for links','feedreading_blogroll')?></th>
        <td>
        <input size="80" id="linkCssClass" name="linkCssClass" type="text" value="<?php echo $feedreading_blogroll_settings['linkCssClass']; ?>" /><br /><a href="http://codex.wordpress.org/Template_Tags/get_bookmarks" title="<?php _e('See Codex-documentation for this feature', 'feedreading_blogroll');?>"><?php _e('Help'); ?></a>
        </td>
    </tr>
    <tr>
        <th scope="row" valign="top"><?php _e('Show update-information','feedreading_blogroll')?></th>
        <td>
        <input id="showLastUpdated" name="showLastUpdated" type="checkbox" value="showLastUpdated" <?php checked('showLastUpdated', $feedreading_blogroll_settings['showLastUpdated']);?> />
        </td>
    </tr>
    <tr>
        <th scope="row" valign="top"><?php _e('Show icon','feedreading_blogroll')?></th>
        <td>
            <input id="showIcon" name="showIcon" type="checkbox" value="showIcon" <?php checked('showIcon', $feedreading_blogroll_settings['showIcon']);?> />
        </td>
    </tr>
</table>
<p class="submit">
  <input name="submit" value="<?php _e('Save Changes'); ?>" type="submit" />
</p>
</form><?php
}


/*
 * Render the widget-body
 */
function widget_feedreading_blogroll($args) {
    extract($args);
    $feedreading_blogroll_settings = get_option('feedreading_blogroll_settings');
    $feedreadingTitle = $feedreading_blogroll_settings['feedreadingTitle']; ?>
    <?php echo $before_widget; ?>
        <?php echo $before_title
            . $feedreadingTitle
            . $after_title; ?>
    <?php widget_feedreading_blogroll_content();?>
    <?php echo $after_widget; ?>
<?php
}


/*
 * Render the widget-control
 */
function widget_feedreading_blogroll_control(){
    $feedreading_blogroll_settings = feedreading_setOptions();
    $linkCssClass                  = $feedreading_blogroll_settings['linkCssClass'];
    $bookmarkArgs                  = $feedreading_blogroll_settings['getBookmarkArgs'];
    $feedreadingTitle              = $feedreading_blogroll_settings['feedreadingTitle'];
    $showLastUpdated               = $feedreading_blogroll_settings['showLastUpdated'];
    $defaultIcon                   = $feedreading_blogroll_settings['defaultIcon'];
    $showIcon                      = $feedreading_blogroll_settings['showIcon'];
    ?> 
    <p>
        <label for="feedreadingTitle"><?php _e('Title')?> <input style="width: 250px;" id="feedreadingTitle" name="feedreadingTitle" type="text" value="<?php echo $feedreadingTitle; ?>" /></label>
    </p>
    <p>
        <label for="linkCssClass"><?php _e('CSS class for links','feedreading_blogroll')?><input style="width: 250px;" id="linkCssClass" name="linkCssClass" type="text" value="<?php echo $linkCssClass; ?>" /></label>
    </p>    
    <p>
        <label for="defaultIcon"><?php _e('Default icon','feedreading_blogroll')?><input style="width: 250px;" id="defaultIcon" name="defaultIcon" type="text" value="<?php echo $defaultIcon; ?>" /></label>
    </p>    
    <p>
        <label for="getBookmarkArgs"><?php _e('Arguments for getBookmarks()','feedreading_blogroll');?> <a href="http://codex.wordpress.org/Template_Tags/get_bookmarks" title="<?php _e('See Codex-documentation for this feature', 'feedreading_blogroll');?>"><?php _e('Help'); ?></a> <input style="width: 250px;" id="getBookmarkArgs" name="getBookmarkArgs" type="text" value="<?php echo $bookmarkArgs; ?>" /></label>
    </p>
    <p>
        <label for="showLastUpdated"><?php _e('Show update-information','feedreading_blogroll')?><br /><input style="width: 250px;" id="showLastUpdated" name="showLastUpdated" type="checkbox" value="showLastUpdated" <?php checked('showLastUpdated',$feedreading_blogroll_settings['showLastUpdated']);?>/></label>
    </p>
    <p>
        <label for="showIcon"><?php _e('Show icon','feedreading_blogroll')?><br /><input style="width: 250px;" id="showIcon" name="showIcon" type="checkbox" value="showIcon" <?php checked('showIcon',$feedreading_blogroll_settings['showIcon']);?>/></label>
    </p>
    <input type="hidden" id="feedreading_blogroll_settings_submit" name="feedreading_blogroll_settings_submit" value="1" />
    <?php 
}


/*
 * Shortcut for non-widget-users
 */
function feedreading_blogroll() {
    widget_feedreading_blogroll_content();
}


/*
 * render content of widget
 */
function widget_feedreading_blogroll_content(){
    $feedreading_blogroll_settings = get_option('feedreading_blogroll_settings');
    $linkCssClass = $feedreading_blogroll_settings['linkCssClass'];
    $args = $feedreading_blogroll_settings['getBookmarkArgs'];
    $showLastUpdated = strcmp($feedreading_blogroll_settings['showLastUpdated'], 'showLastUpdated');
    $showIcon = strcmp($feedreading_blogroll_settings['showIcon'], 'showIcon');
    $defaultIcon = $feedreading_blogroll_settings['defaultIcon'];
    
    ?><ul><?php
    // fetch bookmarks from wordpress
    $bookmarks = get_bookmarks($args);
    
    // extract name, url and feed-url
    foreach ($bookmarks as $bookmark){
        $name=$bookmark->link_name;
        $url=$bookmark->link_url;
        $urlFeed=$bookmark->link_rss;
        $image=$bookmark->link_image;
        // print bookmark
        ?>
        <li><?php if (trim($image) != '' and $showIcon == 0){ 
            ?><img src="<?php echo $image; ?>" style="width:16px; height:16px;" width="16" height="16" alt="Icon" />&nbsp;<?php 
        } else if (trim($image) == '' and $showIcon == 0 and trim($defaultIcon) != ''){ 
            ?><img src="<?php echo trim($defaultIcon); ?>" style="width:16px; height:16px;" width="16" height="16" alt="Icon" />&nbsp;<?php 
        } 
        ?><a href="<?php echo $url;?>" title="<?php echo $name; ?>" rel="external" class="<?php echo $linkCssClass; ?>"><?php echo $name; ?></a><?php
        // if bookmark has feed-info, get update-info and print it
        if (trim($urlFeed)!='' and $showLastUpdated == 0) { ?>
            <br /><span class="lastPublicationDate"><abbr title="<?php _e('last change','feedreading_blogroll');?>"><?php feedreading_blogroll_get_last_updated($urlFeed);
            ?></abbr></span><?php
        }
        ?></li><?php
    }
    ?></ul><?php
}


/*
 * get string containing age of most recent update of the feed
 */
function feedreading_blogroll_get_last_updated($feed_url) {
	$rss = fetch_rss($feed_url);

    $dateStringfromFeed = $rss->channel['pubdate']; 
    //echo '$dateStringfromFeed: |'.strtotime($dateStringfromFeed).'|';
    if (trim($dateStringfromFeed)=='') {
        $dateStringfromFeed=$rss->channel['updated'];
        if (strtotime($dateStringfromFeed)==0 or trim($dateStringfromFeed)==''){
            $item = $rss->items[0];
            $dateStringfromFeed=$item['updated'];
        }
    }
    $tsFromFeed = strtotime($dateStringfromFeed);
    $tsNow      = strtotime('now'); 
    
    
    $dateDiff = $tsNow - $tsFromFeed;
    $fullDays = floor($dateDiff/(60*60*24));
    //echo $dateStringfromFeed.'  '. date('r'). ' '.$fullDays. ' '.$fullHours;
    if ($fullDays > 1) {
        echo $fullDays.' '. __('days ago','feedreading_blogroll');
    } else if ($fullDays == 1) {
        echo $fullDays.' '. __('day ago','feedreading_blogroll');    
    } else if ($fullDays < 1){
        $fullHours = floor(($dateDiff-($fullDays*60*60*24))/(60*60));
        if ($fullHours > 1) {
            echo $fullHours.' '. __('hrs ago','feedreading_blogroll');
        } else if ($fullHours == 1) {
            echo $fullHours.' '. __('hr ago','feedreading_blogroll');
        } else {
            _e('just recently','feedreading_blogroll');
        }
    }
}


/* 
 * add init-action
 */
add_action('widgets_init', 'widget_init_feedreading_blogroll');
add_action('admin_menu', 'feedreading_register_with_options');

?>